searchNodes=[{"doc":"Documentation for ExRoboCop .","ref":"ExRoboCop.html","title":"ExRoboCop","type":"module"},{"doc":"Create a captcha text and a captcha image","ref":"ExRoboCop.html#create_captcha/0","title":"ExRoboCop.create_captcha/0","type":"function"},{"doc":"Store captcha text under a unique ID for later retrieval","ref":"ExRoboCop.html#create_form_id/1","title":"ExRoboCop.create_form_id/1","type":"function"},{"doc":"Compare user answer with correct answer under uuid","ref":"ExRoboCop.html#not_a_robot?/1","title":"ExRoboCop.not_a_robot?/1","type":"function"},{"doc":"Put in application children to start in supervision tree","ref":"ExRoboCop.html#start/0","title":"ExRoboCop.start/0","type":"function"},{"doc":"","ref":"ExRoboCop.html#t:captcha_image/0","title":"ExRoboCop.captcha_image/0","type":"type"},{"doc":"","ref":"ExRoboCop.html#t:captcha_text/0","title":"ExRoboCop.captcha_text/0","type":"type"},{"doc":"","ref":"ExRoboCop.html#t:uuid/0","title":"ExRoboCop.uuid/0","type":"type"},{"doc":"Uses Rust to generate a captcha in the form of a tuple consisting of a string and a base 64 encoded binary","ref":"ExRoboCop.RustCaptcha.html","title":"ExRoboCop.RustCaptcha","type":"module"},{"doc":"","ref":"ExRoboCop.RustCaptcha.html#generate/0","title":"ExRoboCop.RustCaptcha.generate/0","type":"function"},{"doc":"GenServer storing the text of the generated Captcha along with a UIID assigned to each individual user so that the user's captcha answer can be verified","ref":"ExRoboCop.SecretAnswer.html","title":"ExRoboCop.SecretAnswer","type":"module"},{"doc":"","ref":"ExRoboCop.SecretAnswer.html#check_in/1","title":"ExRoboCop.SecretAnswer.check_in/1","type":"function"},{"doc":"","ref":"ExRoboCop.SecretAnswer.html#check_out/1","title":"ExRoboCop.SecretAnswer.check_out/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExRoboCop.SecretAnswer.html#child_spec/1","title":"ExRoboCop.SecretAnswer.child_spec/1","type":"function"},{"doc":"","ref":"ExRoboCop.SecretAnswer.html#start_link/1","title":"ExRoboCop.SecretAnswer.start_link/1","type":"function"},{"doc":"ExRoboCop is a lightweight captcha library that can be used as an alternative to reCaptcha to verify that a person is indeed a person and not a robot. The library uses Rust to create a captcha image and corresponding text. A GenServer creates a unique ID for each form in which a captcha image is used and stores the ID along with the captcha text so that a user's input into the infamous &quot;Not a Robot&quot; field can be verified based on the form ID. The use of this library requires the installation of Rust. Thank you to Alan Vardy for writing the Rust code. Documentation can be found at https://hexdocs.pm/ex_robo_cop . This library is in use at connie.codes .","ref":"README.html","title":"ExRoboCop","type":"extras"},{"doc":"Add the package to your mix.exs file: def deps do [ { :ex_robo_cop , &quot;~&gt; 0.1.0&quot; } ] end Add the application to your supervision tree in the application.ex file, this is the GenServer that keeps track of the correct captcha answer and the form ID: children = [ ExRoboCop . start ( ) ... other children ] And install Rust on your computer.","ref":"README.html#installation","title":"ExRoboCop - Installation","type":"extras"},{"doc":"create_captcha\\0 creates a captcha text and a captcha image create_form_id\\1 creates a unique ID for a contact form and stores it in combination with the current captcha text not_a_robot?\\1 checks whether the combination of the user's answer to the &quot;Not a Robot&quot; question and the form ID match the form ID and captcha text stored in the GenServer","ref":"README.html#usage","title":"ExRoboCop - Usage","type":"extras"},{"doc":"Assuming that you want to use ex_robo_cop to add a captcha to the content form on your website, and that you are working with a contact_controller.ex , a contact_view.ex and a new.html.heex file, you can follow the steps below: First of all, you need to create the captcha text, the captcha image and the id of the new contact form in the ContactController.new/2 function: { captcha_text , captcha_image } = ExRoboCop . create_captcha ( ) form_id = ExRoboCop . create_form_id ( captcha_text ) The call to ExRoboCop.create_form_id\\1 stores the form_id and the captcha_text as a key-value pair in the GenServer. The form_id and the captcha_image will then have to be passed into the assigns of the render\\3 function. In the ContactController of my personal projects, the new/2 function will typically look like this: def new ( conn , _params ) do with { captcha_text , captcha_image } &lt;- ExRoboCop . create_captcha ( ) do form_id = ExRoboCop . create_form_ID ( captcha_text ) render ( conn , &quot;new.html&quot; , page_title : &quot;Contact&quot; , changeset : Contact . changeset ( %{ } ) , form_id : form_id , captcha_image : captcha_image ) end end The next step is rendering the captcha image in the contact form in your .heex template. Since the image data is passed into the render/3 assigns as binary, it needs to be converted in order to be displayed. In Phoenix 1.6, you can add the following function to your corresponding view.ex file: def display_captcha ( captcha_image ) do content_tag ( :img , &quot;&quot; , src : &quot;data:image/png;base64,&quot; &lt;&gt; captcha_image ) end and then call this function in your heex template: &lt;%= display_captcha(@captcha_image) %&gt; In Phoenix 1.5, you can convert the binary directly in the .eex template: &lt;img src=&quot;data:image/png;base64,&lt;%= Base.encode64(@captcha_image)%&gt;&quot;&gt; The form also needs to include an input field for users to input the letters they see in the captcha image as well as a hidden input field through which the form_id can be passed back to the controller when the form is submitted: &lt;div class=&quot;field&quot;&gt; &lt;%= label f, :not_a_robot, class: &quot;label&quot;%&gt; &lt;div class=&quot;control&quot;&gt; &lt;%= text_input f, :not_a_robot, class: &quot;input&quot;, type: &quot;text&quot;, placeholder: &quot;Please enter the letters shown below&quot; %&gt; &lt;/div&gt; &lt;/div&gt; &lt;%= text_input f, :form_id, type: &quot;text&quot;, hidden: true, value: @form_id %&gt; When the form is submitted, the form_id and the user's answer are sent back to the controller as part of the form content. I suggest pattern matching on them in the head of the controller's create/2 function for example like this: def create ( conn , %{ &quot;content&quot; =&gt; %{ &quot;not_a_robot&quot; =&gt; captcha_answer , &quot;form_id&quot; =&gt; form_id } = message_params } ) do Now, you can pass the user's answer and the form_id as a tuple into ExRoboCop.not_a_robot?\\1 in order to verify that the answer matches the captcha text stored for the respective form_id in the GenServer. :ok = not_a_robot? ( { captcha_answer , form_id } )","ref":"README.html#example","title":"ExRoboCop - Example","type":"extras"},{"doc":"Since ex_robo_cop requires Rust, you will need to add the command to install Rust to your Dockerfile : # install build dependencies RUN apt - get update - y &amp;&amp; apt - get install - y build - essential git rustc \\ &amp;&amp; apt - get clean &amp;&amp; rm - f / var / lib / apt / lists / * _ *","ref":"README.html#production","title":"ExRoboCop - Production","type":"extras"},{"doc":"","ref":"CHANGELOG.html","title":"Changelog","type":"extras"},{"doc":"Initial release","ref":"CHANGELOG.html#v0-1-0-2022-03-25","title":"Changelog - v0.1.0 (2022-03-25)","type":"extras"}]